//    LightMP3
//    Copyright (C) 2007 Sakya
//    sakya_tg@yahoo.it
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#include "equalizer.h"
#include "string.h"

struct equalizersList list;

//Equalizers value:
double EQ_None[32]		= {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
double EQ_Rock[32]		= {4.8, 4.8, 4.8, 2.9, 2.9, 2.9, -3.6, -3.6, -3.6, -5.1, -5.1, -5.1, -2.5, -2.5, -2.5, 2.5, 2.5, 2.5, 5, 5, 5, 5.5, 5.5, 5.5, 5.5, 5.5, 5.5, 5.5, 5.5, 5.5, 5.5, 5.5};
double EQ_Classical[32] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -4.8, -4.8, -4.8, -4.8, -4.8, -4.8, -4.8, -4.8, -4.8, -6.3};
double EQ_Pop[32]		= {-1.3, -1.3, -1.3, 2.9, 2.9, 2.9, 4.4, 4.4, 4.4, 4.8, 4.8, 4.8, 4.8, 3.2, 3.2, 3.2, 3.2, 3.2, -1, -1, -1, -1.7, -1.7, -1.7, -1.7, -1.7, -1.7, -1.7, -1.7, -1.7, -1.7, -1.7};
double EQ_Dance[32]		= {5.9, 5.9, 5.9, 5.9, 4.4, 4.4, 4.4, 1.3, 1.3, 1.3, 0, 0, 0, 0, 0, 0, -3.6, -3.6, -3.6, -4.8, -4.8, -4.8, -4.8, -4.8, -4.8, -4.8, 0, 0, 0, 0, 0, 0};
double EQ_Reggae[32]	= {0, 0, 0, 0, 0, 0, 0, -0.6, -0.6, -0.6, -3.6, -3.6, -3.6, -3.6, 0, 0, 0, 4.4, 4.4, 4.4, 4.4, 4.4, 4.4, 0, 0, 0, 0, 0, 0, 0, 0, 0};
double EQ_Soft[32]		= {2.9, 2.9, 2.9, 1, 1, 1, 1, -1, -1, -1, -1.7, -1.7, -1.7, -1, -1, -1, 2.5, 2.5, 2.5, 2.5, 5.1, 5.1, 5.1, 5.9, 5.9, 5.9, 6.7, 6.7, 6.7, 7.4, 7.4, 7.4};

#define EQ_NUMBER 7

//Init:
void EQ_init(){
	struct equalizer tEQ;
	int i;

	//None:
	strcpy(tEQ.name, "None");
	strcpy(tEQ.shortName, "NO");
	for (i = 0; i < 32; i++){
		tEQ.filter[i] = EQ_None[i];
	}
	list.EQ[0] = tEQ;

	//Rock:
	strcpy(tEQ.name, "Rock");
	strcpy(tEQ.shortName, "R");
	for (i = 0; i < 32; i++){
		tEQ.filter[i] = EQ_Rock[i];
	}
	list.EQ[1] = tEQ;

	//Classical:
	strcpy(tEQ.name, "Classical");
	strcpy(tEQ.shortName, "C");
	for (i = 0; i < 32; i++){
		tEQ.filter[i] = EQ_Classical[i];
	}
	list.EQ[2] = tEQ;

	//Pop:
	strcpy(tEQ.name, "Pop");
	strcpy(tEQ.shortName, "P");
	for (i = 0; i < 32; i++){
		tEQ.filter[i] = EQ_Pop[i];
	}
	list.EQ[3] = tEQ;

	//Dance:
	strcpy(tEQ.name, "Dance");
	strcpy(tEQ.shortName, "D");
	for (i = 0; i < 32; i++){
		tEQ.filter[i] = EQ_Dance[i];
	}
	list.EQ[4] = tEQ;

	//Reggae:
	strcpy(tEQ.name, "Reggae");
	strcpy(tEQ.shortName, "RE");
	for (i = 0; i < 32; i++){
		tEQ.filter[i] = EQ_Reggae[i];
	}
	list.EQ[5] = tEQ;

	//Soft:
	strcpy(tEQ.name, "Soft");
	strcpy(tEQ.shortName, "S");
	for (i = 0; i < 32; i++){
		tEQ.filter[i] = EQ_Soft[i];
	}
	list.EQ[6] = tEQ;

}

//Get EQ by name:
struct equalizer EQ_get(char *name){
	int i;
	for (i = 0; i < EQ_NUMBER; i++){
		if (list.EQ[i].name == name){
			return list.EQ[i];
		}
	}
	struct equalizer voidEQ;
	return(voidEQ);
}

//Get EQ by index:
struct equalizer EQ_getIndex(int index){
	if (index < EQ_NUMBER){
		return list.EQ[index];
	}
	struct equalizer voidEQ;
	return(voidEQ);
}

//Get EQ number:
int EQ_getEqualizersNumber(){
	return(EQ_NUMBER);
}
